<script setup>
  import useVuelidate from "@vuelidate/core";
import {
  required,
 
  minLength,
  maxLength,
  
  numeric,
  helpers,
} from "@vuelidate/validators";
import { validName } from "@/validators";
import { ref, reactive, onMounted, computed } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import MainSection from "@/components/MainSection.vue";
import TitleHeading from "@/components/TitleHeading.vue";
import Field from "@/components/Field.vue";
import Control from "@/components/Control.vue";
import FilePicker from "@/components/FilePicker.vue";
import JbButton from "@/components/JbButton.vue";
import BottomOtherPagesSection from "@/components/BottomOtherPagesSection.vue";
import JbButtons from "@/components/JbButtons.vue";
import UserCard from "@/components/UserCard.vue";
import ProfileCard from "@/components/ProfileCard.vue";
import UserAvatar from "@/components/UserAvatar.vue";
import Pill from "@/components/Pill.vue";
import Account from "@/api/account";
import { useToast } from "vue-toastification";
const router = useRouter();
const store = useStore();
const toast = useToast();
const titleStack = ref(["Profile", ""]);
const profileList = reactive({value:{}});
const profile = reactive({ detail: "" });
const upload = ref(null);
const profileImage = ref(null);
const logoImage = ref(null);
onMounted(() => {
  // Get Profile Details
  Account.get().then((data) => {
    console.log("data",data?.success);
    if(data?.success){
      profileList.value = data?.data;
    console.log("profileList", profileList.value);
    console.log("profileitems", profileitems);
    profileImage.value=profileList.value.profileImage;
    profile.detail ={
      firstName:profileList.value.firstName,
      lastName:profileList.value.lastName,
      mobile:profileList.value.mobile
    }
    }
    
  }) .catch((error) => {
      let message =
        error?.response?.data?.message || "something wrong! please try again";
      toast.error(message);
    });
});
// Profile List Store
const profileitems = computed(() => {
  return profileList.value;
});
// Validation
const rules = computed(() => {
  return {
    firstName: {
      required: helpers.withMessage("This field cannot be empty", required),
      validators: {
        $validator: validName,
        $message:
          "Invalid Name. Valid name only contain letters, dashes (-) and spaces",
      },
    },
    lastName: {
      required: helpers.withMessage("This field cannot be empty", required),
      validators: {
        $validator: validName,
        $message:
          "Invalid Name. Valid name only contain letters, dashes (-) and spaces",
      },
    },
    mobile: {
      required: helpers.withMessage("This field cannot be empty", required),
      minLength: minLength(10),
      maxLength: maxLength(10),
      numeric,
    },
   
   
  };
});
const v$ = useVuelidate(rules, profile);
const updateProfile = async () => {

   console.log("profile", profile.detail);
    console.log("upload.value", upload.value);
  let formData = new FormData();
            formData.append("firstName", profile.detail?.firstName);
            formData.append("lastName", profile.detail?.lastName);
            formData.append("mobile", profile.detail?.mobile);
            formData.append("profileImage", upload.value);
            console.log("formData",...formData.entries())
  Account.update(formData).then((data) => {
    console.log("update Profile Data", data?.success);
    if (data?.success) {
      router.push({ path: `/profile/` });
      toast.success(data?.message);
    } else {
      toast.error(data?.message);
      return false;
    }
  });

};
// Image Picked 
const selectLogo=()=> {
      console.log('selectLogo Clicked')
      logoImage.value.click()
    };
 const fileSelected = (event)=>{
      upload.value = event.target.files.item(0);
       console.log("upload.value", upload.value);
      const reader = new FileReader();
      reader.addEventListener('load', imageLoaded);
      reader.readAsDataURL(upload.value );
    };
  const imageLoaded= (event)=>{
      profileImage.value = event.target.result;
    };
</script>

<template>
  <section class="bg-gray-40 md:px-10 px-2 py-10 h-screen">
    <div class="flex w-full py-2">
      <title-heading
        :title-stack="titleStack"
        :to="{
          name: 'profile',
        }"
      />
      <span class="text-lg text-gray-250 font-semibold">Edit Profile</span>
    </div>
    <form class="mt-6">
      <profile-card>
        <level class="flex">
          <img v-if="profileImage"
            :src="profileImage"
            class="justify-left md:w-20 w-16 md:h-20 h-16 items-left border-2 border-pink-250 rounded-full"
          />
          <img v-else
            src="@/assets/icons/user-pic.svg"
            class="justify-left md:w-20 w-16 md:h-20 h-16 items-left border-2 border-pink-250 rounded-full"
          />
          <div class="flex justify-center md:block text-xs pt-6 ml-10 mt-5 md:my-0 my-5">
             <input ref="logoImage" v-show="false" type="file" class="w-16 h-6" accept="image/*" @change="fileSelected"/>
            <pill
            @click="selectLogo"
              text="Add Image"
              class="bg-pink-250 text-white text-xs rounded-full cursor-pointer shadow-lg"
            />
          </div>
        </level>
      </profile-card>
      
      <main-section class="bg-white">
        <h5 class="font-semibold text-black-250 text-base -mt-2 md:px-0 px-2">
          General Info
          
        </h5>
        <div
         
          class="grid grid-cols-1 lg:grid-cols-3 gap-2 mt-6"
        >
          <field label="First Name" star="*">
            <control
              v-model="profile.detail.firstName"
              name="username"
              required
             
              autocomplete="username"
            />
            
          </field>

          <field label="Last Name" star="*">
            <control
              v-model="profile.detail.lastName"
              name="name"
              required
            />
           
          </field>

          <field label="Mobile" star="*">
            <control v-model="profile.detail.mobile" name="number" required />
           
          </field>
        </div>
      </main-section>
    </form>
    <div class="py-6 flex justify-end items-end">
      <jb-buttons>
        <jb-button
          color="light"
          label="Cancel"
          to="/profile"
          class="rounded-md h-10 text-gray-350 px-8 py-3 text-sm"
          :small="buttonsSmall"
          :outline="buttonsOutline"
          :disabled="buttonsDisabled"
        />

        <jb-button
          class="text-white h-10 bg-pink-250 hover:bg-pink-500 rounded-md px-8 py-3 text-sm"
          label="Update"
          @click.prevent="updateProfile"
          :small="buttonsSmall"
          :outline="buttonsOutline"
          :disabled="buttonsDisabled"
        />
      </jb-buttons>
    </div>
  </section>
</template>
